//============================================================================
// Author      : Sanjib Sharma
// Version     :
// Copyright   : Copyright (c) Sanjib Sharma 2010
//============================================================================

#ifndef NODEA_H_
#define NODEA_H_
//#include "sutils.h"
#include "Particle.h"
#include "Splitter.h"

class NodeA
{
public:
	NodeA();
	~NodeA();
	inline  int type(){return 1;};
	void split(Splitter &pStat,int leafSize);
	void print(NodeA* root,Particle* Pa,Particle* Pa2);
	void setUpRoot(Particle* pFirst1, Particle* pLast1,Particle* pFirst11, Particle* pLast11,Splitter &pStat);
	void updateMetric(std::vector<float>  &PMetric,ParticleStats1 &pStat,int items);
	void updateMatrix(std::vector<float>  &PMetric,ParticleStats1 &pStat,int items);
	inline void setChildren(NodeA* child) {left=child;};
	void setLeaf();
	inline NodeA* rightN() {return (left+1);};
	inline NodeA* leftN() {return (left);};
	inline  int  count ( )  const {return (pLast-pFirst);};
	void update_node_realloc(NodeA* rootP,NodeA* rootN)
	{
			if(left!=NULL)
				left=rootN+(left-rootP);
			if(parent!=NULL)
				parent=rootN+(parent-rootP);
	}
private:
	int kSplit;
//	int level;
	NodeA *parent;
	NodeA *left;
public:
	Particle* pFirst;
	Particle* pLast;
	Particle* pFirst2;
	Particle* pLast2;
};



#endif /* NODEA_H_ */
