//============================================================================
// Author      : Sanjib Sharma
// Version     :
// Copyright   : Copyright (c) Sanjib Sharma 2010
//============================================================================
#ifndef TIMER_H_
#define TIMER_H_

#include "sutils.h"



class Timer
{
private:
	clock_t startTime,stopTime;
public:
	Timer();
	~Timer();
	double elapsedTime();
	double currentTime();
	void start();
	void stop();
	void resume();
	void print();
	void print(const char *s);
	void print(const char *s,double n );
	void printC();
	void printC(const char *s);
	void printC(const char *s,double n );
};
void getTypeCheck();

//ostream& operator<< (ostream& os, const Timer& timer1);

#endif /*TIMER_H_*/
