//============================================================================
// Author      : Sanjib Sharma
// Version     :
// Copyright   : Copyright (c) Sanjib Sharma 2010
//============================================================================
#include <algorithm>
#include "Node.h"

Node::Node()
{

}

Node::~Node()
{
}

//ParticleData Pa1;
//ParticleData Node::Pa=Pa1;
//void Node::setPa(ParticleData Pa1)
//{
//	Pa=Pa1;
//}

void Node::print(Node* root,Particle* Pa)
{
	std::cout<<"Node="<<this-root+1<<" count="<<pLast-pFirst<<" pFirst="<<pFirst-Pa<<" pLast ="<<pLast-Pa<<" "<<kSplit<<"  "<<xSplit<<" "<<"x[0]="<<x[0]<<" "<<"x[1]="<<x[1]<<std::endl;
//	std::cout<<bnd[0]<<" "<<bnd[1]<<" "<<bnd[2]<<" "<<bnd[3]<<" "<<bnd[4]<<" "<<bnd[5]<<" "<<std::endl;
}

void Node::setUpRoot(Particle* pFirst1, Particle* pLast1,Splitter &pStat,int maxNodes)
//void Node::setUpRoot(Particle* pFirst1, Particle* pLast1,ParticleStats &pStat)
{
	pFirst=pFirst1;
	pLast=pLast1;
	parent=NULL;
//	int NumPart=(pLast1-pFirst1);
	if(type()==0)
	{
//		bnd1=new double[2*NumPart*2*dim];
//		for(int i=0;i<2*NumPart;i++)
//		{
//			this[i].bnd=&bnd1[i*2*dim];
//		}
//		this[0].bnd=new double[2*NumPart*2*pStat.dim];
//		for(int i=0;i<2*NumPart;i++)
//		{
//			this[i].bnd=this[0].bnd+(i*2*pStat.dim);
//		}
		this[0].bnd=new double[maxNodes*2*pStat.dim];
		for(int i=1;i<maxNodes;i++)
		{
			this[i].bnd=this[0].bnd+(i*2*pStat.dim);
		}
	}
	pStat.computeMinMaxSig(pFirst,pLast,0,pStat.dim);
	for(int k=0;k<pStat.dim;k++)
	{
			bnd[2*k]=pStat.xmin[k]* (1-(10*std::numeric_limits<float>::epsilon()));
			bnd[2*k+1]=pStat.xmax[k]*(1+(10*std::numeric_limits<float>::epsilon()));
	}

};




//class data_less_than: unary_function<class Particle, bool>
//{
//	int kdim;
//	double val;
//public:
//	explicit data_less_than(const int& kdim1,const double& val1):kdim(kdim1), val(val1){}
////	explicit data_less_than(const int& kdim1,const double& val1):kdim(kdim1){}
//	bool operator() (const Particle& Pa) const {return Pa.Pos[kdim]<val;}
//};
//
//class par_less_than: binary_function<Particle, Particle,bool>
//{
//	int kdim;
//public:
//	explicit par_less_than(const int& kdim1):kdim(kdim1){}
////	explicit data_less_than(const int& kdim1,const double& val1):kdim(kdim1){}
//	bool operator() (const Particle& Pa1,const Particle& Pa2) const {return Pa1.Pos[kdim]<Pa2.Pos[kdim];}
//};


void Node::split(Splitter &pStat)
//void Node::split(ParticleStats &pStat)
{
	if(parent==NULL)
	{
		pStat.computeSplitParameters(pFirst,pLast,bnd,-1);
		pStat.check_identical_coord(pFirst,pLast,-1);
	}
	else
	{
		pStat.computeSplitParameters(pFirst,pLast,bnd,parent->kSplit);
		pStat.check_identical_coord(pFirst,pLast,parent->kSplit);
	}
//	computeSplitParameters(dim,pStat);
//	if((kSplit!=pStat.kSplit)||(xSplit!=pStat.xSplit))
//	{
//		std::cout<<kSplit<<" "<<pStat.kSplit<<xSplit<<" "<<pStat.xSplit<<std::endl;
//		exit(1);
//	}
	kSplit=pStat.kSplit;
	xSplit=pStat.xSplit;
//	pStat.print();
//	std::cout<<count()<<" "<<kSplit<<std::endl;
//	if((pStat.xSplit<pStat.xmin[kSplit])||(pStat.xSplit>pStat.xmax[kSplit]))
//	{
//		std::cout<<"Split not done1 "<<pStat.xmin[kSplit]<<" "<<pStat.xmax[kSplit]<<"  "<<xSplit<<" "<<kSplit<<" "<<pLast-pFirst<<std::endl;
//	}
	x[0]=bnd[2*kSplit];
	x[1]=bnd[2*kSplit+1];

	//	std::cout<<xSplit<<std::endl;
	Particle* pSplit=partition(pFirst, pLast, data_less_than(kSplit, xSplit));
	xSplit=(max_element(pFirst,pSplit,par_less_than(kSplit))->Pos[kSplit] +min_element(pSplit,pLast,par_less_than(kSplit))->Pos[kSplit])*0.5;



	if ((pSplit==pFirst)||(pSplit==pLast))
	{
//		std::cout<<"Split not done "<<pStat.xmin[kSplit]<<" "<<pStat.xmax[kSplit]
//				<<"  "<<xSplit<<" "<<kSplit<<" "<<pStat.count1<<std::endl;
//		std::cout<<"Split not done "<<pStat.xmin[kSplit]<<" "<<pStat.xmax[kSplit]
//				<<"  "<<x[0]<<" "<<x[1]<<" "<<pStat.count1<<std::endl;

//		for(int k=0;k<pStat.dim;++k)
//			std::cout<<"Split not done "<<pStat.xmin[k]<<" "<<pStat.xmax[k]
//				<<"  "<<xSplit<<" "<<pLast-pFirst<<std::endl;
//		for(int k=0;k<dim;++k)
		std::cout<<"correcting identical co-ordinates"<<std::endl;
//		std::cout<<"Split not done1 "<<pStat.xmin[kSplit]<<" "<<pStat.xmax[kSplit]<<"  "<<xSplit<<" "<<kSplit<<" "<<pLast-pFirst<<x[0]<<" "<<x[1]<<std::endl;
//		for(int k=0;k<pStat.dim;++k)
//			std::cout<<setprecision(6)<<"k="<<k<<" xmin="<<pStat.xmin[k]<<" xmax="<<pStat.xmax[k]<<std::endl;
		pFirst->Pos[kSplit]=x[0]+(xSplit-x[0])*0.5;
		pSplit=pFirst+1;
//				exit(1);
	}

//	left->initialize(this,pSplit,0)
//	right()->initialize(this,pSplit,1)
	// initialize left right  node parametrs
	int j;

	leftN()->parent=this;
	leftN()->pFirst=pFirst;
	leftN()->pLast=pSplit;
	for (int k=0; k<pStat.dim; k++)
	{
		j=k<<1; //j=k*2
		leftN()->bnd[j]=bnd[j];
		leftN()->bnd[j+1]=bnd[j+1];
	}
	leftN()->bnd[(kSplit<<1)+1]=xSplit;

	rightN()->parent=this;
	rightN()->pFirst=pSplit;
	rightN()->pLast=pLast;
	for (int k=0; k<pStat.dim; k++)
	{
		j=k<<1; //j=k*2
		rightN()->bnd[j]=bnd[j];
		rightN()->bnd[j+1]=bnd[j+1];
	}
	rightN()->bnd[(kSplit<<1)]=xSplit;

}




//void Node::computeSplitParameters(int dim,ParticleStats &pStat)
//{
//	if(pStat.treeType==0)
//	{
//		pStat.computeMinMaxSig(pFirst,pLast,0,dim);
//		kSplit=max_element(pStat.xsig,pStat.xsig+dim)-pStat.xsig;
//	}
//	if(pStat.treeType==1)
//	{
//		pStat.computeMinMaxSig(pFirst,pLast,0,dim);
//		if(parent!=NULL)
//			kSplit=(parent->kSplit+1)%dim;
//		else
//			kSplit=0;
//	}
//	if(pStat.treeType==2)
//	{
//		pStat.compute1dEntropy(pFirst,pLast,bnd) ;
//		if(parent==NULL)
//			kSplit=pStat.computekSplit(-1);
//		else
//			kSplit=pStat.computekSplit(parent->kSplit);
//		if(count()<2)
//			kSplit=(parent->kSplit+1)%dim;
//	}
//	if (pStat.treeType==3)
//	{
//		pStat.compute3dEntropy(pFirst, pLast, bnd) ;
//		if (parent==NULL)
//			kSplit=pStat.computekSplit(-1);
//		else
//			kSplit=pStat.computekSplit(parent->kSplit);
//		if (count()<2)
//			kSplit=(parent->kSplit+1)%dim;
//
//	}
//
////	if(parent!=NULL)
////	std::cout<<kSplit<<" "<<parent->kSplit<<" "<<pStat.count1<<" "<<pStat.en[0]<<" "<<pStat.en[1]<<" "<<pStat.en[2]<<std::endl;
//
//	pStat.kSplit=kSplit;
//	xSplit=pStat.computexSplit(pFirst,pLast);
//
//}

//void Node::setUpBoundary (ParticleStats &pStat)
//{
//	pStat.computeMinMaxSig(pFirst,pLast,0,dim);
//	for(int k=0;k<pStat.dim;k++)
//	{
//			bnd[2*k]=pStat.xmin[k]* (1-(10*numeric_limits<float>::epsilon()));
//			bnd[2*k+1]=pStat.xmax[k]*(1+(10*numeric_limits<float>::epsilon()));
//	}
//
//};
